local addonName, addon = ...

_G[addonName] = addon

--[[-----------------------------------------------------------------------------
Guild and Friend Invite DropDown Menu Buttons
-------------------------------------------------------------------------------]]
local GUIDropDownAdd = CreateFrame("Frame","GUIDropDownAdd")
GUIDropDownAdd:SetScript("OnEvent", function() hooksecurefunc("UnitPopup_ShowMenu", GDropDownCheck) end)
GUIDropDownAdd:RegisterEvent("PLAYER_LOGIN")

local PopupUnits = {"PARTY", "PLAYER", "RAID_PLAYER", "RAID", "FRIEND", "TEAM", "CHAT_ROSTER", "TARGET", "FOCUS"}

local AddFriendButtonInfo = {
	text = "Add Friend",
	value = "ADD_FRIEND",
	func = function() AddFriend(UIDROPDOWNMENU_OPEN_MENU.name) end,
	notCheckable = 1,
}

local RemoveFriendButtonInfo = {
	text = "Remove Friend",
	value = "REMOVE_FRIEND",
	func = function() RemoveFriend(UIDROPDOWNMENU_OPEN_MENU.name) end,
	notCheckable = 1,
}

local GuildInviteButtonInfo = {
	text = "Guild Invite",
	value = "GUILD_INVITE",
	func = function() GuildInvite(UIDROPDOWNMENU_OPEN_MENU.name) end,
	notCheckable = 1,
}

local CancelButtonInfo = {
	text = "Cancel",
	value = "CANCEL",
	notCheckable = 1
}

function GDropDownCheck()		

	local GoodUnit = false
	for i=1, #PopupUnits do	
		if OPEN_DROPDOWNMENUS[1]["which"] == PopupUnits[i] then	
			GoodUnit = true
		end
	end
	
	if UIDROPDOWNMENU_OPEN_MENU["unit"] == "target" and ((not UnitIsPlayer("target")) or (not UnitIsFriend("player", "target"))) then
		GoodUnit = false
	end

		--local SetFocusButton = getglobal("DropDownList1Button2")
		--SetFocusButton:Hide() 

		if UIDROPDOWNMENU_OPEN_MENU["unit"] == "player" and addon.settings.hideBlizPlayerFrame == true or UIDROPDOWNMENU_OPEN_MENU["unit"] == "target" and addon.settings.hideBlizTargetFrame == true or UIDROPDOWNMENU_OPEN_MENU["unit"] == "party" and addon.settings.hideBlizPartyFrames == true then
			local MoveFrameDropRem = getglobal("DropDownList1Button"..DropDownList1.numButtons -1)
			MoveFrameDropRem:Hide()
		end
		--DropDownList1.numButtons = DropDownList1.numButtons - 1
	
	if GoodUnit then	
		local CancelButtonFrame = getglobal("DropDownList1Button"..DropDownList1.numButtons)
		CancelButtonFrame:Hide() 
		DropDownList1.numButtons = DropDownList1.numButtons - 1
		
		local PossibleButton1 = getglobal("DropDownList1Button"..(DropDownList1.numButtons))
		local PossibleButton2 = getglobal("DropDownList1Button"..(DropDownList1.numButtons)-1)

		local IsAlreadyFriend = false
		for z=1, GetNumFriends() do
			if GetFriendInfo(z) == UIDROPDOWNMENU_OPEN_MENU["name"] or UIDROPDOWNMENU_OPEN_MENU["name"] == UnitName("player") then
				IsAlreadyFriend = true
			end
		end
		
		if not IsAlreadyFriend then				-- is this person not already your friend?
			if PossibleButton2["value"] ~= "ADD_FRIEND" and PossibleButton1["value"] ~= "ADD_FRIEND" then
				UIDropDownMenu_AddButton(AddFriendButtonInfo)			-- Add the button
			end
		else
			if PossibleButton2["value"] ~= "REMOVE_FRIEND" and PossibleButton1["value"] ~= "REMOVE_FRIEND" then
				UIDropDownMenu_AddButton(RemoveFriendButtonInfo)
			end
		end

		if PossibleButton1["value"] ~= "GUILD_INVITE" and PossibleButton2["value"] ~= "GUILD_INVITE" then
			local targetGuilded = GetGuildInfo("target")
			
			if IsInGuild() and CanGuildInvite() and (not UnitIsInMyGuild("target")) and targetGuilded == nil then
					UIDropDownMenu_AddButton(GuildInviteButtonInfo)			-- Add the button
			end
		end

		UIDropDownMenu_AddButton(CancelButtonInfo)
	
	end
end

--[[-----------------------------------------------------------------------------
BattleNet notifications
-------------------------------------------------------------------------------]]
hooksecurefunc("BNToastFrame_Show", function(self)
	BNToastFrame:ClearAllPoints()
	BNToastFrame:SetPoint("TOPLEFT", UIParent, "TOPLEFT", 200, -70)
end)

--[[-----------------------------------------------------------------------------
Achivement Alert Frame
-------------------------------------------------------------------------------]]
--hooksecurefunc("AchievementAlertFrame_FixAnchors", function(self)

	--AchievementAlertFrame1:ClearAllPoints()
	--AchievementAlertFrame1:SetPoint("TOP", UIParent, "TOP", 0, -50)

--end)

function AchievementAlertFrame_FixAnchors ()
	-- Temporary (here's hoping) workaround so that achievement alerts are anchored to loot roll windows. Eventually we want one system to handle placement for both alerts.
	if ( not AchievementAlertFrame1 ) then
		-- We haven't displayed any achievement alerts yet, so there's nothing to reanchor (read: this got called by LootFrame.lua)
		return;
	end
	
	for i=NUM_GROUP_LOOT_FRAMES, 1, -1  do
		local frame = _G["GroupLootFrame"..i];
		if ( frame and frame:IsShown() ) then
			AchievementAlertFrame1:SetPoint("BOTTOM", frame, "TOP", 0, 10);
			return;
		end
	end
	AchievementAlertFrame1:ClearAllPoints()
	AchievementAlertFrame1:SetPoint("TOP", UIParent, "TOP", 0, -50)
end

function AchievementAlertFrame_GetAlertFrame()
	local name, frame, previousFrame;
	for i=1, MAX_ACHIEVEMENT_ALERTS do
		name = "AchievementAlertFrame"..i;
		frame = _G[name];
		if ( frame ) then
			if ( not frame:IsShown() ) then
				return frame;
			end
		else
			frame = CreateFrame("Button", name, UIParent, "AchievementAlertFrameTemplate");
			if ( not previousFrame ) then
				frame:SetPoint("TOP", UIParent, "TOP", 0, -50);
			else
				frame:SetPoint("TOP", previousFrame, "BOTTOM", 0, -10);
			end
			return frame;
		end
		previousFrame = frame;
	end
	return nil;
end